/*
 * command.h:
 * Definitions for client commands.
 *
 * Copyright (c) 2004 Chris Lightfoot. All rights reserved.
 * Email: chris@ex-parrot.com; WWW: http://www.ex-parrot.com/~chris/
 *
 * $Id: command.h,v 1.3 2004/04/25 20:10:35 chris Exp $
 *
 */

#ifndef __COMMAND_H_ /* include guard */
#define __COMMAND_H_

/* struct command_state
 * States a client can be in. */
struct command_state {
    enum {
        c_nocommand = 0,
        c_notstarted,
        c_init,
        c_flowcontrol,
        c_baud_digit,
    } s_state;
    int s_accum; /* used to accumulate baud information */
};

/* enum command_result
 * Possible results of trying to interpret a command. */
enum command_result {
    r_nothing,          /* no action to take */
    r_finished,         /* leave command mode */
    r_badcommand,       /* leave command mode, warn user */
    r_disconnect,       /* disconnect client gracefully */
    r_client_error,
    r_tty_error
};

enum command_result command_process(const char *tty, int tty_fd, int client_fd, struct command_state *state, char c);

#endif /* __COMMAND_H_ */
