/*
 * tty.h:
 * Terminal stuff.
 *
 * Copyright (c) 2004 Chris Lightfoot. All rights reserved.
 * Email: chris@ex-parrot.com; WWW: http://www.ex-parrot.com/~chris/
 *
 * $Id: tty.h,v 1.1 2004/06/22 19:22:47 chris Exp $
 *
 */

#ifndef __TTY_H_ /* include guard */
#define __TTY_H_

#include <termios.h>

/* struct serial_options
 * Simple description of options for a TTY. */
struct serial_options {
    speed_t so_rate;
    int so_databits;
    enum { p_none = 0, p_odd = 1, p_even = 2 } so_parity;
    enum { f_none = 0, f_hw = 1, f_sw = 2 } so_flowcontrol;
};

/* tty.c */
int parse_serial_options(const char *str, struct serial_options *S);
char *describe_serial_options(const struct serial_options *O);
int get_serial_options(int fd, struct serial_options *O);
int set_serial_options(int fd, const struct serial_options *O);

#endif /* __TTY_H_ */
